#download relevante packages, installeer en activeer ze:
packages <- c("xlsx")
for(i in 1 : length(packages)){
    if (!require(packages[i], character.only = TRUE)) install.packages(packages[i])
    library(packages[i], character.only = TRUE)
}


#maak functie om resultaten weg te schrijven
writeOutcomes2Excel <- function(data, cijfer, sheet = "Blad_1", excelfile = "out.xlsx", sluit = FALSE){
  result <- data[, cijfer]
  if(is.factor(result)) result <- as.numeric(levels(result)[result])
  colnr <- which(names(data) == cijfer)
  wb <- createWorkbook()
  sheet <- createSheet(wb, sheet)
  cb <- CellBlock(sheet, 1, 1, 400, 50)
  cns <- CellStyle(wb) + Font(wb, heightInPoints = 12, isBold = TRUE, isItalic = TRUE,
                              name = "Courier New") + Border(pen = "BORDER_THICK")
  addDataFrame(data, sheet, row.names = FALSE, startRow = 1, startCol = 1, colnamesStyle = cns)
  setColumnWidth(sheet, 1:ncol(data), 15)

  # highlight onvoldoende in red
  fill <- Fill(foregroundColor = "red")
  ind  <- which(matrix(result < 5.5), arr.ind = TRUE)
  CB.setFill(cb, fill, ind[,1] + 1, ind[,2] + colnr - 1)  # note the indices offset

  # highlight goed in green
  fill <- Fill(foregroundColor = "green")
  ind  <- which(matrix(result > 6.9), arr.ind = TRUE)
  CB.setFill(cb, fill, ind[,1] + 1, ind[,2] + colnr - 1)  # note the indices offset

  # highlight voldoende in orange
  fill <- Fill(foregroundColor = "orange")
  ind  <- which(matrix(result > 5.4 & result < 7), arr.ind = TRUE)
  CB.setFill(cb, fill, ind[,1] + 1, ind[,2] + colnr - 1)  # note the indices offset

  #saveWorkbook(wb, excelfile)
  if(sluit) saveWorkbook(wb, excelfile)
  wb
}

#Haal gegevens eerste week binnen:
download.file(url = "https://surfdrive.surf.nl/files/index.php/s/48oXoxszqmsN1o3/download", destfile = "Toets1.xlsx", mode = "wb")
#Merk op dat de studentnamen en nummers gefingeerd zijn
bestand <- read.xlsx(file = "Toets1.xlsx", sheetIndex = 1)

#selecteer data en geef nieuwe namen:
data_kort <- bestand[c("Username", "Date", "Duration", paste("Opgave", 1:10, sep = "_"), "Grade")]
names(data_kort) <- c("StudentID", "Datum", "Duur (min)", paste("Opgave", 1:10, sep = "_"), "Cijfer")

#maak excelfile met informatie over studenten en opgaven:

wb <- writeOutcomes2Excel(data_kort, "Cijfer")
sheet <- getSheets(wb)[1]

#gegevens per item:

items <- names(data_kort)[grep( "Opgave", names(data_kort))]
P <- colMeans(data_kort[, items], na.rm = TRUE)
Q <- 1 - P
png("barplot.png", height = 1400, width = 2400, res = 250, pointsize = 8)
barplot(height = rbind(P, Q), names.arg = items, main = "Itemanalyse", ylab = "Proportie correct")
dev.off()

# Add the plot created previously to wb
addPicture("barplot.png", sheet$Blad_1, scale = 1, startRow = 20,
           startColumn = 1)
# remove the plot from the disk
res <- file.remove("barplot.png")

# save excel
saveWorkbook(wb, paste("ResultatenWeek1.xlsx", sep = ""))
